<?php
if (!defined('FORUM_ROOT'))
	define('FORUM_ROOT', './../../');

if (!defined('FORUM_ROOT'))	die();

function pun_pm_archiving() 
{
    global $forum_url, $lang_pm_archiving;
	
	ob_start();
?>
	<div class="main-subhead">
		<h2 class="hn"><span><?php echo $lang_pm_archiving['Archiving Private Messages'] ?></span></h2>
	</div>
	<div class="main-content main-frm">
		<form id="afocus" class="frm-form" name="pun_pm_sendform" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['pun_pm_archive_messages']) ?>">
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pun_pm_archive_messages'])) ?>" />
			</div>
			<div class="sf-set">
				<div class="sf-box select">
					<label><span><?php echo $lang_pm_archiving['Export to'] ?>:</span></label><br />
					<span class="fld-input"><select name="file_type">
						<option value="txt" selected="selected"><?php echo $lang_pm_archiving['TXT'] ?></option>
						<option value="html"><?php echo $lang_pm_archiving['HTML'] ?></option>
					</select></span>
				</div>
			</div>
			<div class="frm-buttons">
				<span class="submit primary"><input type="submit" name="pm_archive" value="<?php echo $lang_pm_archiving['Create'] ?>" /></span>
			</div>
		</form>
	</div>
<?php

	$result = ob_get_contents();
	ob_end_clean();

	return $result;
}

function get_all_user_pm_messages_txt()
{
	global $forum_db, $forum_user, $lang_pm_archiving;

	$query = array(
		'SELECT'	=> 'm.id, m.status, u1.username AS sender, u2.username AS receiver, read_at, lastedited_at as sent_at, subject, body as message',
		'FROM'		=> 'pun_pm_messages AS m',
		'JOINS'		=> array(
			array(
				'LEFT JOIN'		=> 'users AS u1',
				'ON'			=> '(u1.id=sender_id)'
			),
			array(
				'LEFT JOIN'		=> 'users AS u2',
				'ON'			=> '(u2.id=receiver_id)'
			),
		),
		'WHERE'		=> '((m.sender_id='.$forum_user['id'].' AND m.deleted_by_sender=0) OR (m.receiver_id='.$forum_user['id'].' AND m.deleted_by_receiver=0))',
		'ORDER BY'  => 'lastedited_at DESC'
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

	$messages = array();
	while ($row = $forum_db->fetch_assoc($result))
		$messages[] = $row;
	
	if (count($messages))
	{
		$msg_backup = [];
		foreach($messages as $msg)
		{
			if ($msg['status'] == 'read')
				$status = $lang_pm_archiving['Read'].' - '.date('j-m-Y', $msg['read_at']).' '.date('H:i', $msg['read_at']);
			else if ($msg['status'] == 'delivered')
				$status = $lang_pm_archiving['Delivered'];
			else
				$status = $lang_pm_archiving['Sent'];
			
			$msg_backup[] = '#'.$msg['id']."\r\n\t".
			                $lang_pm_archiving['Sender'].': '.$msg['sender']."\r\n\t".
			                $lang_pm_archiving['Receiver'].': '.$msg['receiver']."\r\n\t".
			                $lang_pm_archiving['Date sent'].': '.date('j-m-Y', $msg['sent_at']).' '.date('H:i', $msg['sent_at'])."\r\n\t".
			                $lang_pm_archiving['Status'].': '.$status."\r\n\t".
			                $lang_pm_archiving['Subject'].': '.$msg['subject']."\r\n\t".
			                $lang_pm_archiving['Message'].': '.$msg['message']."\r";
		}
	}

	return (count($messages)) ? implode("\n",$msg_backup) : $lang_pm_archiving['No saved private messages'];
}

function get_all_user_pm_messages_html()
{
	global $forum_db, $forum_user, $forum_url, $forum_date_formats, $lang_pm_archiving, $smilies;

    $query = array(
		'SELECT'	=> 'm.id, m.sender_id, m.receiver_id, m.status, u1.username AS sender, u2.username AS receiver, read_at, lastedited_at as sent_at, subject, body as message',
		'FROM'		=> 'pun_pm_messages AS m',
		'JOINS'		=> array(
			array(
				'LEFT JOIN'		=> 'users AS u1',
				'ON'			=> '(u1.id=sender_id)'
			),
			array(
				'LEFT JOIN'		=> 'users AS u2',
				'ON'			=> '(u2.id=receiver_id)'
			),
		),
		'WHERE'		=> '((m.sender_id='.$forum_user['id'].' AND m.deleted_by_sender=0) OR (m.receiver_id='.$forum_user['id'].' AND m.deleted_by_receiver=0))',
		'ORDER BY'  => 'lastedited_at DESC'
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	if ($forum_db->num_rows($result) > 0)
	{
		if (!defined('FORUM_PARSER_LOADED'))
		    require FORUM_ROOT.'include/parser.php';

	    ob_start();
?>
	    <!DOCTYPE html>
        <html lang="ru" dir="ltr">
        <head>
            <meta charset="utf-8" />
            <meta name="viewport" content="width=device-width, initial-scale=1.0">
        </head>
		<style>
            html, body, div, p, dl, dt, dd, ul, ol, li, h1, h2, h3, h4, h5, h6, pre, blockquote, table, th, td {margin: 0; padding: 0; text-align: left;}
			samp, code, pre {font-family: monospace, sans-serif; white-space: pre-wrap; word-wrap: break-word;}
			samp, code, pre, option, optgroup, input, select, textarea, td, th {font-size: 1em; font-family: Verdana, Helvetica, Arial, sans-serif; font-style: normal; font-weight: normal;}
			body {color: #222;}
			.brd {padding: 1em 2em; margin: 0 auto; max-width: 1100px; min-width: 700px; width: 90%;}
            .brd-page {float: left; width: 100%; position: relative; font: 75%/1.5em Verdana, Helvetica, Arial, sans-serif;}
			.main-subhead {border-color: #d3dae1 #D3DAE1 #cbd1d8 #D3DAE1; background: #f4f4f4;}
			.main-subhead {border-style: solid; border-bottom-style: solid; border-width: 1px; border-bottom-width: 1px; border-bottom: 0; border-bottom-color: currentcolor;}
			.main-subhead .hn {padding: .462em 1.417em; position: relative; font-size: 1em; font-weight: normal;}
			.gen-content, .main-content {background: #fbfbfb; border-color: #d3dae1; border-bottom-color: rgb(211, 218, 225); border-bottom-color: #cbd1d8;}
			.main-content, #brd-visit, #brd-qpost, #brd-announcement {margin-bottom: 1em;}
			.main-content, .gen-content {border-style: solid; border-width: 1px;}
			.pun_pm_msg, .pun_pm_msg .post-entry .entry-content {margin: 1em .7em; width: auto !important;}
			.pun_pm_msg .post-entry {margin: 0; margin-bottom: 0px; padding: 0; margin-bottom: 1.5em;}
			.pun-pm-ct-box {border-style: solid; border-width: 1px; border-color: #dbe0e4; -moz-border-radius: .35em; -webkit-border-radius: .35em; -khtml-border-radius: .35em; border-radius: .35em; margin: 1.417em; padding: .5em 1em; position: relative;}
			.entry-content {padding-bottom: 2em; overflow: hidden; width: 100%; /*min-height: 7em;*/}
			.entry-content .quotebox, .entry-content .codebox {background: #fff; border-color: #ddd; border-style: solid; border-width: 1px; margin: .75em 1em; padding: 1em .75em;}
			.entry-content .quotebox cite {display: block; font-style: normal; font-weight: bold;}
			.entry-content blockquote {overflow: hidden; width: 100%;}
			.entry-content .quotebox, .entry-content .codebox {background: #fff; border-color: #ddd; border-style: solid; border-width: 1px; margin: .75em 1em; padding: 1em .75em;}
			.entry-content .codebox {background: #fff; border-color: #ddd; font-size: .97em;}
			.entry-content pre {margin: 0; max-height: 35em; min-height: 2em; overflow: auto; padding: 0 2% .1em 0; width: 98%;}
			.entry-content img {vertical-align: text-top; max-width: 100%;}
			fieldset, img, cite {border: 0;}
            p, .hn {padding: .35em 0;}
			a:hover, a:active, a:focus {color: #cd0021; text-decoration: underline;}
			a:link, a:visited, .js_link {color: #00579c; text-decoration: none;}
			table {width: 100%; table-layout: fixed; empty-cells: show; border-spacing: 0; line-height: 1.3333em; border-collapse: collapse;}
			.pun_pm_msg .td1 {font-weight: bold; width: 17.7em; padding-right: 1em; text-align: right; vertical-align: top;}
			.pun_pm_msg table td {width: auto; border-width: 0; padding: .3em 0; padding-right: 0px;}
			.main-item, .main-item li, .main-item div, td {border-color: #dde4eb;}
			td {padding: .5em 1.417em; border-width: 1px; border-style: solid none none solid; overflow: hidden; vertical-align: middle; font-size: 1em; font-family: Verdana, Helvetica, Arial, sans-serif; font-style: normal; font-weight: normal;}
        </style>
        <body>
	    <div id="brd-wrap" class="brd">
	    <div id="brd-pun_pm-outbox" class="brd-page menu-page">
	    <div id="brd-main">
<?php
		while ($msg = $forum_db->fetch_assoc($result))
		{
	        if ($msg['status'] == 'read')
				$status = $lang_pm_archiving['Read'].' - '.date('j-m-Y', $msg['read_at']).' '.date('H:i', $msg['read_at']);
			else if ($msg['status'] == 'delivered')
				$status = $lang_pm_archiving['Delivered'];
			else
				$status = $lang_pm_archiving['Sent'];

	        $sender = $msg['sender_id'] != $forum_user['id'] ? '<a href="'.forum_link($forum_url['user'], $msg['sender_id']).'" target="_blank">'.forum_htmlencode($msg['sender']).'</a>' : forum_htmlencode($msg['sender']);
			$receiver = $msg['receiver_id'] != $forum_user['id'] ? '<a href="'.forum_link($forum_url['user'], $msg['receiver_id']).'" target="_blank">'.forum_htmlencode($msg['receiver']).'</a>' : forum_htmlencode($msg['receiver']);
			
			$messages = parse_message($msg['message'], false);

			$messages = preg_replace_callback(
				'~<a.*?href="(.*?)".*?>~i',
				function ($matches) {
				    if (!preg_match_all('~target="(.*?)~i', $matches[0], $targetMatches)) {
					    return str_replace('<a', '<a target="_blank"', $matches[0]);
				    }
					                
					return $matches[0];
				},
				$messages
			);

			$messages = preg_replace_callback("/<(img|image)[\s]+[^>]*src=['\"]?([^'\"\s>]+)['\"]?[^>]*>/is", "getImageDataFromUrl", $messages);
?>
			
			<div class="pm_msg">
		        <div class="main-subhead">
		            <h2 class="hn"><span>#<?php echo $msg['id'] ?></span></h2>
	            </div>
	            <div class="main-content frm">
			        <div class="pun_pm_msg">
				    <table>
					    <tbody>
						    <tr>
							    <td class="td1"><?php echo $lang_pm_archiving['Sender'] ?>:</td>
							    <td><?php echo $sender ?></td>
						    </tr>
						    <tr>
							    <td class="td1"><?php echo $lang_pm_archiving['Receiver'] ?>:</td>
							    <td><?php echo $receiver ?></td>
						    </tr>
						    <tr>
							    <td class="td1"><?php echo $lang_pm_archiving['Date sent'] ?>:</td>
							    <td><?php echo format_time($msg['sent_at'], 0, $forum_date_formats[$forum_user['date_format']]) ?></td>
						     </tr>
						    <tr>
							    <td class="td1"><?php echo $lang_pm_archiving['Status'] ?>:</td>
							    <td><?php echo $status ?></td>
						    </tr>
						    <tr>
							    <td class="td1"><?php echo $lang_pm_archiving['Subject'] ?>:</td>
							    <td><?php echo $msg['subject'] ?></td>
						    </tr>
					    </tbody>
				    </table>
			        </div>
			        <div class="pun_pm_msg"><div class="post-entry"><div class="entry-content pun-pm-ct-box"><?php echo $messages ?></div></div></div>
				</div>
		    </div>
<?php	
        }	
?>
		</div></div></div>
        </body>
        </html>
<?php
	    $r_result = ob_get_contents();
	    ob_end_clean();

	    return $r_result;
	} else {
		return $lang_pm_archiving['No saved private messages'];
	}
}

if ( ! function_exists('getImageDataFromUrl'))
{
	function getImageDataFromUrl($url)
    {
        $timeout = 10;

	    if (function_exists('ini_set'))
		    @ini_set('default_socket_timeout', $timeout);
	
        if (function_exists('curl_init'))
	    {
	        $urlParts = pathinfo($url[2]);
            $extension = $urlParts['extension'];
		    $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $url[2]);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($ch, CURLOPT_HEADER, 0);
	        curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
            $response = @curl_exec($ch);
            $responce_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
		    curl_close($ch);

		    if ($response !== false && $responce_code == '200')
		    {
                return '<img src="data:image/' . $extension . ';base64,' . base64_encode($response).'">';
		    } else {
			    return '<img src="'.$url[2].'">';
		    }
	    } else {
		    return '<img src="'.$url[2].'">';
	    }
    }
}

define('PM_ARCHIVING_FUNCTIONS_LOADED', 1);
